package org.omegahat.DataStructures.Data;

import org.omegahat.Environment.Language.Evaluable;



/**
 A {@link DataList DataList} that is derived as a subset of
a parent {@link DataList DataList} by specifying
indeces or using an 
{@link org.omegahat.Environment.Tools.DataScanner.ObjectReader ObjectReader}.
The idea is that this is linked to the parent and
in the future will receive events that affect the elements
that are shared between it and its parent (and potentially
other children).
*/

public class SubsetDataList extends DataList {
  /** 
     The {@link DataList DataList} object from which this
     was derived.
   */
 protected DataList source = null;

 public SubsetDataList() {
 }


 public SubsetDataList(DataList parent) {
   source(parent);
 }

/**
  The expression is ignored currently.
*/
 public SubsetDataList(DataList parent, Evaluable expression) {
   this(parent);
 }

 public DataList source() {
   return(source);
 }

 public DataList source(DataList s) {
   source = s;
   return(source());
 }

}

/*
Copyright (c) 1998, 1999 The Omega Project for Statistical Computing.
     All rights reserved.

     Redistribution and use in source and binary forms, with or without
     modification, are permitted provided that the following conditions are
     met:

       Redistributions of source code must retain the above copyright notice,
       this list of conditions and the following disclaimer.

       Redistributions in binary form must reproduce the above copyright
       notice, this list of conditions and the following disclaimer in the
       documentation and/or other materials provided with the distribution.

       Neither name of the Omega Project for Statistical Computing nor the 
       names of its contributors may be used to endorse or promote products 
       derived from this software without specific prior written permission.

     THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ``AS IS'' AND ANY
     EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
     MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT
     SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
     SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
     PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
     INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
     STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
     THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. 
*/

